; Maus bewegen
; ===========================================
;
; AutoIt Version: 3.0
; OS: Windows 2000 deutsch
; Vertauschung X-Y korrigiert - 10.05.2013
; ProcessExists taskmgr.exe ruft Pause - 10.05.2013
; Y-Bereich -40 wegen DVB-TV - 10.05.2013
; TrayToolTip "Pause" - 28.10.2013
; TrayTip bei Start zeigt Sekunden an - 28.10.2013
; PosBeep als Func, Beep bei Ctrl-P - 14.05.2015
; Pause grundlegend umgebaut wegen TrayMenue - 14.05.2015
; Sound CloseBeep - 14.05.2015
; sleep 1000 weil Paused = 1 Last zieht - 24.06.2017
; MouseMove nur noch bei Paused = 0 - 24.06.2017
;

$Version = "Version : 2017-06-24"
$Version = $Version &" / " &@AutoItVersion

Opt("GUICloseOnESC", 0)      ;1=ESC  closes, 0=ESC won't close
Opt("TrayAutoPause",0)       ;0=no pause, 1=Pause
Opt("TrayIconHide", 0)       ;0=show, 1=hide tray icon
Opt("MouseCoordMode", 1)  ;1=absolute, 0=relative, 2=client
Opt("MouseClickDownDelay", 25)  ;10 milliseconds
Opt("SendKeyDelay", 5)  ;5 milliseconds
Opt("SendKeyDownDelay", 10)  ;1 milliseconds
Opt("TrayMenuMode", 3)         ; Default tray menu items (Script Paused/Exit) will not be shown.
Opt("TrayOnEventMode", 1)

$PosBeep = "Pos_700_950_SQ.wav"
  LocPath ($PosBeep)
$CloseSound = "Doorslam.wav"
  LocPath ($CloseSound)

Global $Paused = 0

; HotKeySet("^+m", "Weiter")
HotKeySet("^x", "Ende")
HotKeySet("^p", "Pause")

$RestartTime = TrayCreateItem($Version)
TrayCreateItem("")
$TrayPause = TrayCreateItem("Pause")
 TrayItemSetOnEvent ($TrayPause, "Pause")
TrayCreateItem("")
$TrayExit = TrayCreateItem("Exit")
 TrayItemSetOnEvent ($TrayExit, "Ende")

TraySetToolTip (" Maus zyklisch bewegen" &@CRLF &" damit der Zeiger nicht festklebt ")
; TrayTip ($Version, @DesktopHeight &" x " &@DesktopWidth &@CRLF &@DesktopDepth  &" bit / " &@DesktopRefresh &" Hz" &@CRLF &"Ctrl+P = Pause" &@CRLF &"Ctrl+X = Ende", 20, 1)

If $CmdLine[0] = 0 Then
   $Time = "10000"
Else
   $Time = $CmdLine[1]
Endif

If $Time < 500 then $Time = 500

TrayTip ($Version, $Time / 1000 &"  Sekunden" &@CRLF &@DesktopHeight &" x " &@DesktopWidth &@CRLF &@DesktopDepth  &" bit / " &@DesktopRefresh &" Hz" &@CRLF &"Ctrl+P = Pause" &@CRLF &"Ctrl+X = Ende", 20, 1)

If $Time < 2000 Then
  Sleep (2000)
Else
  Sleep ($Time)
EndIf

Do
  If $Paused = 1 Then
;   MsgBox (262144, "debug", "Paused-Loop")
    Sleep (1000) ; zieht sonst erheblich Last
    ContinueLoop
  EndIf
  $X = Random (30, @DesktopWidth-30, 1)
  $Y = Random (30, @DesktopHeight-40, 1)
  $RdTime = Random ($Time, $Time*3, 1)
  If ProcessExists ("taskmgr.exe") then
;   MsgBox (262144, "debug", "Taskman detektiert")
    $Paused = 0
    Pause () ; 0 wird zu 1 getoggelt und angezeigt
  EndIf
  If $Paused = 0 Then MouseMove ($X, $Y)
  sleep ($RdTime)
until @Min = 99 ; wird nie gueltig

Func Pause()  ; Toggle Pause
  PosBeep ()
  If $Paused > 0 Then
    $Paused = 0
    TrayTip ("Clear", "", 0)
    TraySetToolTip (" Maus zyklisch bewegen" &@CRLF &" damit der Zeiger nicht festklebt ")
  Else
    $Paused = 1
    TrayTip ("Pause", @HOUR &" : " &@MIN &" Uhr", 30, 2)
    TraySetToolTip (" " &@CRLF &"   Pause   " &@CRLF &" ")
  EndIf
EndFunc

Func LocPath (ByRef $Wert) ; wenn kein "\" drin lokalen Pfad voranstellen
  If FileExists (@WindowsDir &"\Media\" &$Wert) then
    $Wert = @WindowsDir &"\Media\" &$Wert
  Endif
  If not StringInStr ( $Wert, "\" ) then
    $Wert = @ScriptDir &"\" &$Wert
  Endif
EndFunc

Func PosBeep ()
  If FileExists ($PosBeep) Then
    SoundPlay($PosBeep, 1)
  Else
    Beep(700, 99)
    sleep (100)
    Beep(950, 75)
  EndIf
EndFunc

Func CloseBeep ()
  If FileExists ($CloseSound) Then
    SoundPlay($CloseSound, 1)
  Else
    Beep(950, 100)
    sleep (100)
    Beep(700, 175)
  EndIf
EndFunc

Func Ende()
  CloseBeep ()
  sleep (50)
  Exit
EndFunc
